function [f,g] = logistic_regression(theta, X,y)
  %
  % Arguments:
  %   theta - A column vector containing the parameter values to optimize.
  %   X - The examples stored in a matrix.  
  %       X(i,j) is the i'th coordinate of the j'th example.
  %   y - The label for each example.  y(j) is the j'th example's label.
  %
  g = zeros(size(theta));


  %
  % TODO:  Compute the objective function by looping over the dataset and summing
  %        up the objective values for each example.  Store the result in 'f'.
  
  htheta = 1./(1+exp(-X'*theta));
  part1 = log(htheta).*y';
  part2 = (1-y').*log(1-htheta);
  f = -sum(part1 + part2);
  % TODO:  Compute the gradient of the objective by looping over the dataset and summing
  %        up the gradients (df/dtheta) for each example. Store the result in 'g'.
  %
  cost = 1./(1+exp(-X'*theta))-y';
  repCost = repmat(cost, 1, size(X',2));
  g = sum(X'.*repCost, 1);
  g = g';
%%% YOUR CODE HERE %%%
